/*****************************************/
/*  Header Hopfield pattern learner      */
/*****************************************/

#ifndef CLASS_CASSOCMEM_ATMA
#define CLASS_CASSOCMEM_ATMA

/*****************************************/

#include <stdlib.h>
#include <iostream.h>
#include <time.h>

/*****************************************/

#define LEARNING_RATE   (float)0.5

/*****************************************/

#ifndef ULONG
typedef unsigned long ULONG;
#endif

/*****************************************/

#define _go_binary(x)  ((x == -1) ? 0 : 1)
#define _go_bipolar(x) ((x) ? 1 : -1)

/*****************************************/

/*-----------------------------------------------------------------------*\
    Namespace: Atma, finally not :)
\*-----------------------------------------------------------------------*/

/*namespace Atma
{*/

class CAssocmem
{
    public:
    
        /*Constructors and destructor*/
    
        CAssocmem();
        CAssocmem(ULONG size);
        ~CAssocmem();
        
        /*Training function*/
        
        void Train(int** input, ULONG nb_patterns);
        
        void Run(int* input);
        
        int* Get_Outputs();
        
    private:

        void Process_Net();
        
        bool Process_Neuron(ULONG number);

        void Set_Treshold();
        
        ULONG   nb_neurons;
        
        int**   weights;
        int*    treshold;
        int*    outputs;
        
};        

/*-----------------------------------------------------------------------*\
    End of namespace
\*-----------------------------------------------------------------------*/

//}
/*****************************************/

#endif

/*****************************************/
/*                 EOF                   */
/*****************************************/
        
